import { renderless, api } from "@dft-vue-2-opentiny/vue-renderless/numeric/vue";
import { defineComponent, directive, props, setup as _setup } from "@dft-vue-2-opentiny/vue-common";
import bind from "@dft-vue-2-opentiny/vue-renderless/common/deps/repeat-click";
import { IconChevronDown, IconChevronUp, IconMinus, IconPlus } from "@dft-vue-2-opentiny/vue-icon";
function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  if (functionalTemplate) {
    options.functional = true;
  }
  if (scopeId) {
    options._scopeId = "data-v-" + scopeId;
  }
  var hook;
  if (moduleIdentifier) {
    hook = function hook2(context) {
      context = context || // cached call
      this.$vnode && this.$vnode.ssrContext || // stateful
      this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext;
      if (!context && typeof __VUE_SSR_CONTEXT__ !== "undefined") {
        context = __VUE_SSR_CONTEXT__;
      }
      if (injectStyles) {
        injectStyles.call(this, context);
      }
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier);
      }
    };
    options._ssrRegister = hook;
  } else if (injectStyles) {
    hook = shadowMode ? function() {
      injectStyles.call(this, (options.functional ? this.parent : this).$root.$options.shadowRoot);
    } : injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

var classes = {
  "numeric": "relative flex items-center w-24 h-7 text-sm",
  "numeric_display_none": "hidden",
  "numeric_size": "sm:w-24 sm:h-7 sm:text-xs",
  "numeric_medium": "sm:w-32 sm:h-8 sm:text-sm",
  "numeric_decrease": "absolute z-10 text-center cursor-pointer left-0 flex items-center justify-center bg-color-bg-2 active:bg-color-border-separator focus:bg-border-separator sm:bg-inherit sm:active:bg-inherit sm:focus:bg-inherit w-7 h-7 leading-7 border-0.5 border-color-border-separator rounded-l-sm sm:border-0",
  "numeric_increase": "absolute z-10 text-center cursor-pointer right-0 flex items-center justify-center bg-color-bg-2 active:bg-color-border-separator focus:bg-border-separator sm:bg-inherit sm:active:bg-inherit sm:focus:bg-inherit w-7 h-7 leading-7 border-0.5 border-color-border-separator rounded-r-sm sm:border-0",
  "numeric_crease_disabled": "bg-color-bg-4 active:bg-color-bg-4 focus:bg-color-bg-4",
  "numeric_svg": "sm:w-4 sm:h-4 w-3.5 h-3.5 inline-block fill-color-icon-primary sm:hover:fill-color-brand-hover sm:active:fill-color-brand-active sm:focus:fill-color-brand-active",
  "numeric_svg_disabled": "fill-color-text-disabled cursor-not-allowed",
  "numeric_svg_size": "sm:w-7 sm:h-7 sm:leading-7 sm:text-xs",
  "numeric_svg_medium": "sm:w-8 sm:h-8 sm:leading-8 sm:text-sm",
  "numeric_input": "w-full block leading-3",
  "numeric_input-medium-unit": "sm:px-3 px-2",
  "numeric_input-medium-num": "sm:px-8 px-9",
  "numeric_input-default-unit": "px-2",
  "numeric_input-default-num": "px-8 sm:px-9",
  "numeric_input-active": "border-0.5 sm:border border-solid rounded-sm border-color-border-separator sm:border-color-border ",
  "numeric_input-disabled": "bg-inherit sm:bg-color-bg-4 cursor-not-allowed",
  "numeric_input_inner": "w-full z-10 h-7 leading-7 sm:text-xs inline-block overflow-hidden outline-0",
  "numeric-text-center": "text-center",
  "numeric-text-left": "text-left",
  "numeric_input_inner_size": "h-7 leading-7 text-sm",
  "numeric_input_inner_medium": "sm:h-8 sm:leading-8 text-sm sm:text-sm"
};
var __vue2_script = defineComponent({
  directives: directive({
    repeatClick: {
      bind
    }
  }),
  components: {
    IconChevronDown: IconChevronDown(),
    IconChevronUp: IconChevronUp(),
    IconMinus: IconMinus(),
    IconPlus: IconPlus()
  },
  props: [].concat(props, ["step", "tabindex", "stepStrictly", "max", "min", "modelValue", "disabled", "size", "controls", "controlsPosition", "name", "label", "placeholder", "precision", "circulate", "mouseWheel", "validateEvent", "allowEmpty", "format", "unit", "stringMode", "holdZero", "plugin", "modelTruncation", "strictInput", "hideUnit", "unitCenter", "displayOnly"]),
  emits: ["blur", "focus", "update:modelValue", "change", "paste-error"],
  setup: function setup(props2, context) {
    return _setup({
      props: props2,
      context,
      renderless,
      api,
      classes
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "w-auto h-7 flex items-center",
    attrs: {
      "data-tag": "tiny-numeric"
    }
  }, [_c("div", {
    class: _vm.m(_vm.gcls("numeric"), _vm.state.inputSize === "medium" ? _vm.gcls("numeric_medium") : _vm.gcls("numeric_size"), _vm.state.inputDisabled ? _vm.gcls("numeric_disabled") : ""),
    on: {
      "dragstart": function dragstart($event) {
        $event.preventDefault();
      },
      "&mousewheel": function mousewheel($event) {
        return _vm.mouseEvent($event);
      }
    }
  }, [_c("span", {
    directives: [{
      name: "repeat-click",
      rawName: "v-repeat-click",
      value: _vm.decrease,
      expression: "decrease"
    }],
    class: _vm.m(_vm.gcls("numeric_decrease"), _vm.state.inputSize === "medium" ? _vm.gcls("numeric_svg_medium") : _vm.gcls("numeric_svg_size"), _vm.state.minDisabled || _vm.state.inputDisabled ? _vm.gcls("numeric_crease_disabled") : ""),
    attrs: {
      "role": "button"
    },
    on: {
      "keydown": function keydown($event) {
        if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "enter", 13, $event.key, "Enter"))
          return null;
        return _vm.decrease($event);
      }
    }
  }, [_c(_vm.state.controlsAtRight ? "icon-chevron-down" : "icon-minus", {
    tag: "component",
    class: _vm.m(_vm.state.minDisabled || _vm.state.inputDisabled ? _vm.gcls("numeric_svg_disabled") : _vm.gcls("numeric_svg"))
  })], 1), _c("div", {
    class: ["sm:w-px sm:h-4 sm:bg-color-text-disabled sm:absolute", _vm.state.inputSize === "medium" ? "sm:left-8" : "sm:left-7"]
  }), _c("span", {
    directives: [{
      name: "repeat-click",
      rawName: "v-repeat-click",
      value: _vm.increase,
      expression: "increase"
    }],
    class: _vm.m(_vm.gcls("numeric_increase"), _vm.state.inputSize === "medium" ? _vm.gcls("numeric_svg_medium") : _vm.gcls("numeric_svg_size"), _vm.state.minDisabled || _vm.state.inputDisabled ? _vm.gcls("numeric_crease_disabled") : ""),
    attrs: {
      "role": "button"
    },
    on: {
      "keydown": function keydown($event) {
        if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "enter", 13, $event.key, "Enter"))
          return null;
        return _vm.increase($event);
      }
    }
  }, [_c(_vm.state.controlsAtRight ? "icon-chevron-up" : "icon-plus", {
    tag: "component",
    class: _vm.state.maxDisabled || _vm.state.inputDisabled ? _vm.gcls("numeric_svg_disabled") : _vm.gcls("numeric_svg")
  })], 1), _c("div", {
    class: ["sm:w-px sm:h-4 sm:bg-color-text-disabled sm:absolute", _vm.state.inputSize === "medium" ? "sm:right-8" : "sm:right-7"]
  }), _c("div", {
    class: _vm.state.inputSize === "medium" ? _vm.gcls("numeric_input_medium") : _vm.gcls("numeric_input")
  }, [_c("input", {
    ref: "input",
    class: _vm.m(_vm.gcls("numeric_input_inner"), _vm.state.inputSize === "medium" ? _vm.gcls("numeric_input_inner_medium") : _vm.gcls("numeric_input_inner_size"), _vm.state.inputDisabled ? _vm.gcls("numeric_input_inner_disabled") : _vm.gcls("numeric_input_inner_default")),
    attrs: {
      "tabindex": _vm.tabindex,
      "disabled": _vm.state.inputDisabled,
      "placeholder": _vm.placeholder,
      "max": _vm.max,
      "min": _vm.min,
      "name": _vm.name,
      "aria-label": _vm.label
    },
    domProps: {
      "value": _vm.state.displayValue
    },
    on: {
      "keydown": [function($event) {
        if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "up", 38, $event.key, ["Up", "ArrowUp"]))
          return null;
        $event.preventDefault();
        return _vm.increase($event);
      }, function($event) {
        if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "down", 40, $event.key, ["Down", "ArrowDown"]))
          return null;
        $event.preventDefault();
        return _vm.decrease($event);
      }],
      "blur": _vm.handleBlur,
      "focus": _vm.handleFocus,
      "input": _vm.handleInput,
      "change": _vm.handleInputChange
    }
  })])]), _c("div", {
    staticClass: "h-0 right-0 flex ml-2 text-xs sm:h-7 items-center"
  }, [_vm._v(" " + _vm._s(_vm.unit) + " ")])]);
};
var staticRenderFns = [];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles, null, null, null);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var mobileFirst = /* @__PURE__ */ function() {
  return __component__.exports;
}();
export {
  mobileFirst as default
};
